package eCommerce;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

//interacts with the db
//classes that need to do db stuff can instantiate it and call its functions
public class DataAccess {
	
	private Connection connection;
	
	//constructor (connects)
	public DataAccess(){
		
		//this.test = "I'm in ur data attempt.";
		System.out.println("-------- MySQL JDBC Connection Testing ------------");
		 
		try {
 
			Class.forName("com.mysql.jdbc.Driver");
 
		} catch (ClassNotFoundException e) {
 
			System.out.println("Where is your MySQL JDBC Driver?");
			e.printStackTrace();
			return;
 
		}
 
		System.out.println("MySQL JDBC Driver Registered!");
		this.connection = null;
 
		try {
			connection = DriverManager
					.getConnection("jdbc:mysql://localhost:3306/jsf_store",
							"root", "");
 
		} catch (SQLException e) {
			System.out.println("Connection Failed! Check output console");
			e.printStackTrace();
			return;
		}
 
		if (connection != null) {
			System.out.println("You made it, take control your database now!");
		}

		
	}
	
	//get Product ArrayList
    public ArrayList<Product> getProductArrayList() throws SQLException{
	 
    	ArrayList <Product> products = new ArrayList<Product>();
    	
		if (connection != null) {
						
			java.sql.PreparedStatement statement = connection.prepareStatement("select * from products");

			ResultSet result = statement.executeQuery();

			while(result.next()){
				Product prod = new Product();
	 
				prod.setProductId(result.getInt(1));
				prod.setName(result.getString(2));
				prod.setDescription(result.getString(3));
				prod.setImageSource(result.getString(4));
				prod.setPrice(result.getFloat(5));
	 
				//store all data into a ArrayList
				products.add(prod);
			}
			
		} 
		else {
			System.out.println("Failed to make connection!");
		}
    	
    	return products;
    }
    
    //db stores booleans as small integers, so this is necessary
    private int bool2int(boolean boolIn)
    {
    	if (boolIn)
    		return 1;
    	else
    		return 0; 	
    }
    
    //save orders
    public int saveOrder(OrderDetail orderIn) throws SQLException
    {
    	int newOrderNo = 0;
    	
    	//save the order itself
    	String insertTableSQL = "INSERT INTO `jsf_store`.`orders` ("
+ "`order_id` ,"
+ "`customer_id` ,"
+ "`tofn` ,"
+ "`toln` ,"
+ "`toadr1` ,"
+ "`toadr2` ,"
+ "`tocomm` ,"
+ "`tostprov` ,"
+ "`topscd` ,"
+ "`tocntry` ,"
+ "`comments` ,"
+ "`created`"
+ ")"
+ "VALUES ("
+ "NULL , '" + Integer.toString(orderIn.getCustNum()) + "', '" + orderIn.getShipFirstName() + "', '" + orderIn.getShipLastName() + "', '" + orderIn.getShipAddress1() + "', '" + orderIn.getShipAddress2() + "', '" + orderIn.getShipCommunity() + "', '" + orderIn.getShipStateProv() + "', '" + orderIn.getShipPostCode() + "', '" + orderIn.getShipCountry() + "', '" + orderIn.getComments() + "', ?"
+ ");";
    	java.sql.PreparedStatement statement = connection.prepareStatement(insertTableSQL);
    	java.util.Date now = new java.util.Date();
		statement.setTimestamp(1, new java.sql.Timestamp( now.getTime() ) );  
		statement.executeUpdate();
		
		
		//and what was the order # we just inserted?
		java.sql.PreparedStatement statement2 = connection.prepareStatement("select * from orders");
		ResultSet result = statement2.executeQuery();
		while(result.next())
		{
		     newOrderNo = result.getInt(1);
		}
		
		
		//now save to the orders_products join table
		String insertJoinSQL = "";
		java.sql.PreparedStatement statement_join = null;
		ArrayList<OrderedItems> orderToSave = orderIn.getOrderFinal();
		
		for (int i=0;i<orderToSave.size();i++)
		{
		//loop
		insertJoinSQL = "INSERT INTO `jsf_store`.`orders_products` ("
+ "`op_id` ,"
+ "`order_id` ,"
+ "`product_id` ,"
+ "`quantity` ,"
+ "`price`"
+ ")"
+ "VALUES ("
+ "NULL , '" + Integer.toString(newOrderNo) + "', '" + Integer.toString(orderToSave.get(i).getProductID()) + "', '" + Integer.toString(orderToSave.get(i).getQty()) + "', '" + orderToSave.get(i).getPrice().toPlainString() + "'"
+ ");";
		statement_join = connection.prepareStatement(insertJoinSQL);
		statement_join.executeUpdate();
		//end loop
		}
		
		return newOrderNo;//order number
    }
    
    //compare id/pwd with db record
    public Customer verifyCustomer(int Id, String Password) throws SQLException
    {
    	int cNM = 0;
    	String cPWD = "";
    	String fetchCustomerSQL = "SELECT * "
+ "FROM customers "
+ "WHERE customer_id = '1' "
+ "AND cuspwd = 'godatabase';";
    			
    	java.sql.PreparedStatement statement = connection.prepareStatement(fetchCustomerSQL);
    	ResultSet result = statement.executeQuery();
    	
    	Customer cust = new Customer();

		while(result.next()){
			
 			cust.setCustNum(result.getInt(1));
			cNM = result.getInt(1);
			cust.setFirstName(result.getString(2));
			cust.setLastName(result.getString(3));
			cust.setGender(result.getInt(4));
			cust.setPassword(result.getString(5));
			cPWD = result.getString(5);
			cust.setTelephoneNumber(result.getString(6));
			cust.setAltTelephoneNumber(result.getString(7));
			cust.setFaxNumber(result.getString(8));
			cust.setBillAddress1(result.getString(9));
			cust.setBillAddress2(result.getString(10));
			cust.setBillCommunity(result.getString(11));
			cust.setBillStateProv(result.getString(12));
			cust.setBillPostCode(result.getString(13));
			cust.setBillCountry(result.getString(14));
		}
    	
        //if found
		if (cNM == Id && cPWD.equals(Password))
			return cust;
		else
			return null;
    }
    
    //save a new customer record
    public int saveCustomer(Customer custIn) throws SQLException
    {
    	int newCustNo = 0;
    	
		String insertTableSQL = "INSERT INTO `jsf_store`.`customers` ("
+ "`customer_id` ,"
+ "`cufn` ,"
+ "`culn` ,"
+ "`cusgen` ,"
+ "`cuspwd` ,"
+ "`tel` ,"
+ "`altel` ,"
+ "`fax` ,"
+ "`biladr1` ,"
+ "`biladr2` ,"
+ "`bilcomm` ,"
+ "`bilstprov` ,"
+ "`bilpscd` ,"
+ "`bilcntry`"
+ ")"
+ "VALUES ("
+ "NULL , '" + custIn.getFirstName() + "', '" + custIn.getLastName() + "', '" + Integer.toString(bool2int(custIn.isGender())) + "', '" + custIn.getPassword() + "', '" + custIn.getTelephoneNumber() + "', '" + custIn.getAltTelephoneNumber() + "', '" + custIn.getFaxNumber() + "', '" + custIn.getBillAddress1() + "', '" + custIn.getBillAddress2() + "', '" + custIn.getBillCommunity() + "', '" + custIn.getBillStateProv() + "', '" + custIn.getBillPostCode() + "', '" + custIn.getBillCountry() + "'"
+ ");";
		java.sql.PreparedStatement statement = connection.prepareStatement(insertTableSQL);
		statement.executeUpdate();
		
		//and what was the customer # we just inserted?
		java.sql.PreparedStatement statement2 = connection.prepareStatement("select * from customers");
		ResultSet result = statement2.executeQuery();
		while(result.next())
		{
		     newCustNo = result.getInt(1);
		}
    	return newCustNo;//customer number
    }
    
    //update existing customer record
    public void updateCustomer(Customer custIn) throws SQLException
    {
    	String genInsert;
    	if (custIn.isGender())
    		genInsert = "1";
    	else
    		genInsert = "0";
    	
    	String updateCustSQL = "UPDATE `jsf_store`.`customers` SET `cufn` = '" + custIn.getFirstName() + "',"
+ "`culn` = '" + custIn.getLastName() + "',"
+ "`cusgen` = '" + genInsert + "',"
+ "`cuspwd` = '" + custIn.getPassword() + "',"
+ "`tel` = '" + custIn.getTelephoneNumber() + "',"
+ "`altel` = '" + custIn.getAltTelephoneNumber() + "',"
+ "`fax` = '" + custIn.getFaxNumber() + "',"
+ "`biladr1` = '" + custIn.getBillAddress1() + "',"
+ "`biladr2` = '" + custIn.getBillAddress2() + "',"
+ "`bilcomm` = '" + custIn.getBillCommunity() + "',"
+ "`bilstprov` = '" + custIn.getBillStateProv() + "',"
+ "`bilpscd` = '" + custIn.getBillPostCode() + "',"
+ "`bilcntry` = '" + custIn.getBillCountry() + "' WHERE `customers`.`customer_id` =" + custIn.getCustNum() + ";";

    	java.sql.PreparedStatement statement = connection.prepareStatement(updateCustSQL);
		statement.executeUpdate();
		
    }

}
