package eCommerce;

import java.sql.SQLException;
import java.util.ArrayList;

import javax.faces.bean.ManagedBean;

//keeps the order and its shipping information
@ManagedBean
public class OrderDetail {
	
	//UI
	private String shipURL = "shipping.jsf";
	private String finishURL = "success.jsf";
	private String shipERR = "";

	//Customer associated with order
	private Customer inCustomer;
	
	//numbers from db
	private int custNum = 0;
	private int orderNum = 0;
	
	//order items to be inserted in db
	private ArrayList<OrderedItems> orderFinal;

	//shipping info
	private String shipFirstName = "";
	private String shipLastName = "";
    private String shipAddress1 = "";
    private String shipAddress2 = "";
    private String shipCommunity = "";
    private String shipStateProv = "";
    private String shipPostCode = "";
    private String shipCountry = "";
    
    //other
    private String comments;
	
    //setters and getters
	public String getShipERR() {
		return shipERR;
	}
    
	public String getShipAddress1() {
		return shipAddress1;
	}

	public void setShipAddress1(String shipAddress1) {
		this.shipAddress1 = shipAddress1;
	}

	public String getShipAddress2() {
		return shipAddress2;
	}

	public void setShipAddress2(String shipAddress2) {
		this.shipAddress2 = shipAddress2;
	}

	public String getShipCommunity() {
		return shipCommunity;
	}

	public void setShipCommunity(String shipCommunity) {
		this.shipCommunity = shipCommunity;
	}

	public String getShipStateProv() {
		return shipStateProv;
	}

	public void setShipStateProv(String shipStateProv) {
		this.shipStateProv = shipStateProv;
	}

	public String getShipPostCode() {
		return shipPostCode;
	}

	public void setShipPostCode(String shipPostCode) {
		this.shipPostCode = shipPostCode;
	}

	public String getShipCountry() {
		return shipCountry;
	}

	public void setShipCountry(String shipCountry) {
		this.shipCountry = shipCountry;
	}
	
	public String getShipFirstName() {
		return shipFirstName;
	}

	public void setShipFirstName(String shipFirstName) {
		this.shipFirstName = shipFirstName;
	}

	public String getShipLastName() {
		return shipLastName;
	}

	public void setShipLastName(String shipLastName) {
		this.shipLastName = shipLastName;
	}

	public String getComments() {
		return comments;
	}

	public void setComments(String comments) {
		this.comments = comments;
	}
	
	public Customer getInCustomer() {
		return inCustomer;
	}

	public void setInCustomer(Customer inCustomer) {
		this.inCustomer = inCustomer;
	}
	
	public int getCustNum() {
		return custNum;
	}

	public void setCustNum(int custNum) {
		this.custNum = custNum;
	}

	public int getOrderNum() {
		return orderNum;
	}

	public void setOrderNum(int orderNum) {
		this.orderNum = orderNum;
	}
	
	public ArrayList<OrderedItems> getOrderFinal() {
		return orderFinal;
	}

	public void setOrderFinal(ArrayList<OrderedItems> orderFinal) {
		this.orderFinal = orderFinal;
	}
	
	//when customer clicks "same as billing"
	public String makeSame() {
		this.shipFirstName = inCustomer.getFirstName();
		this.shipLastName = inCustomer.getLastName();
		this.shipAddress1 = inCustomer.getBillAddress1();
		this.shipAddress2 = inCustomer.getBillAddress2();
	    this.shipCommunity = inCustomer.getBillCommunity();
	    this.shipStateProv = inCustomer.getBillStateProv();
	    this.shipPostCode = inCustomer.getBillPostCode();
	    this.shipCountry = inCustomer.getBillCountry();
		return shipURL;
	}
	
	//lock in the order after confirming valid details	
	public String goConfirm() {
		//make sure shipping info is valid
		//return shipURL if not
		if (this.shipFirstName == "" || this.shipLastName == "")
		{
			shipERR = "You must enter first and last names.";
			return shipURL;
		}
		if (this.shipAddress1 == "")
		{
			shipERR = "You must enter an address.";
			return shipURL;
		}
		if (this.shipCommunity == "")
		{
			shipERR = "You must enter a community.";
			return shipURL;
		}
		if (this.shipCountry == "")
		{
			shipERR = "You must enter a country.";
			return shipURL;
		}
		this.custNum = inCustomer.getCustNum();
		//save the order!
		DataAccess myAccess = new DataAccess();
		try {
			this.orderNum = myAccess.saveOrder(this);
		} catch (SQLException e) {
			e.printStackTrace();
		} 
		return finishURL; //should also clear this?
		//right now pushing back makes an order resubmit
		
	}
	



}
