package eCommerce;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
 
//each instance of this class
//is an item in a cart
//kind of like a Product, but has a quantity
//and an combined price - can be independent of Product if necessary
@ManagedBean(name="order")
@SessionScoped
public class OrderedItems implements Serializable{

		/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	    //testing
	    private String debugMsg1 = "";
		private String debugMsg2 = "";
		private String debugMsg3 = "";
	    
	    //properties of cart items
	    private int productID;
	    private String productName;
	    private String imageSrc;
	    private BigDecimal singleUnitPrice;
		private BigDecimal price;
	    private int qty;
	    private boolean removeMe = false;

		//default constructor - sanity check of zero items, zero price
		public OrderedItems() {
			productID = -1;
			productName = "NOSALE";
            imageSrc = "AREYOUKIDDING";
            price = new BigDecimal(0);
            qty = 0;

		}
		
		//practical constructor that we'll actually use
		public OrderedItems(int productIDin, String productNameIn, String imageSrcIn, String priceIn, String singPriceIn, int qtyIn) {
			 productID = productIDin;
            productName = productNameIn;
            imageSrc = imageSrcIn;
            price = new BigDecimal(priceIn);
            singleUnitPrice = new BigDecimal(singPriceIn);
            qty = qtyIn;
		}
	    
	    //setters and getters
		public boolean isRemoveMe() {
			return removeMe;
		}

		public void setRemoveMe(boolean removeMe) {
			this.removeMe = removeMe;
		}

		public String getProductName() {
			return productName;
		}
		public void setProductName(String productName) {
			this.productName = productName;
		}
		public BigDecimal getPrice() {
			return price;
		}
		public void setPrice(BigDecimal price) {
			this.price = price;
		}
		public int getQty() {
			return qty;
		}

		public String getImageSrc() {
			return imageSrc;
		}
		public void setImageSrc(String imageSrc) {
			this.imageSrc = imageSrc;
		}
	    public int getProductID() {
			return productID;
		}
		public void setProductID(int productID) {
			this.productID = productID;
		}
		
	    public String getDebugMsg1() {
			return debugMsg1;
		}

		public void setDebugMsg1(String debugMsg1) {
			this.debugMsg1 = debugMsg1;
		}

		public String getDebugMsg2() {
			return debugMsg2;
		}

		public void setDebugMsg2(String debugMsg2) {
			this.debugMsg2 = debugMsg2;
		}
		
		public String getDebugMsg3() {
			return debugMsg3;
		}

		public void setDebugMsg3(String debugMsg3) {
			this.debugMsg3 = debugMsg3;
		}
		
	    public BigDecimal getSingleUnitPrice() {
			return singleUnitPrice;
		}

		public void setSingleUnitPrice(BigDecimal singleUnitPrice) {
			this.singleUnitPrice = singleUnitPrice;
		}
		
		//setter with logic - if a user enters -1 or something, the quantity should be 0
		public void setQty(int qty) {
			if (qty >= 0)
			this.qty = qty;
			else this.qty = 0;
			debugMsg1 = Integer.toString(this.qty);
			BigDecimal newQty = new BigDecimal(this.qty);
			debugMsg2 = newQty.toPlainString();
			this.price = singleUnitPrice.multiply(newQty);
			debugMsg3 = this.price.toPlainString();
		}
		
		
	}